/*
 * Created on 29.04.2005
 *
 * Copyright (c) 2004
 * Telecooperation Office (TecO), Universitaet Karlsruhe (TH), Germany.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 3. Neither the name of the Universitaet Karlsruhe (TH) nor the names
 *    of its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

package edu.teco.particles.pComponent.sender;

import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.text.ParseException;

import javax.swing.DefaultCellEditor;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.TransferHandler;
import javax.swing.UIManager;
import javax.swing.text.DefaultFormatter;
import javax.swing.text.MaskFormatter;

/**
 * @author scholl
 */
public class TupleEditor extends JPanel
{

  private javax.swing.JPanel   jContentPane         = null;

  private JFormattedTextField  TypeTextField = null;

  private JFormattedTextField  DataTextField  = null;

  private JLabel               jLabel               = null;

  private JLabel               jLabel1              = null;

  private JTable               jTable               = null;

  private JScrollPane          jScrollPane          = null;

  private JPanel               jPanel               = null;

  private JButton              addButton              = null;

  private JButton              removeButton             = null;

  private JButton              clearButton             = null;

  protected ProxyParticleTuple _proxyTuple          = new ProxyParticleTuple();

  /**
   * This is the default constructor
   */
  public TupleEditor()
  {
    super();
    initialize();
  }

  /**
   * This method initializes this
   * 
   * @return void
   */
  private void initialize()
  {    
	// bug workaround.
	UIManager.put("Textfield.background", getDataTextField().getBackground() );
	
    jLabel1 = new JLabel();
    jLabel = new JLabel();
    GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
    GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
    this.setLayout(new GridBagLayout());
    this.setBorder(javax.swing.BorderFactory.createTitledBorder(null,
        "ACL Data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
        javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
    this.setSize(300, 200);
    gridBagConstraints7.gridx = 0;
    gridBagConstraints7.gridy = 2;
    gridBagConstraints7.weightx = 1.0;
    gridBagConstraints7.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints7.insets = new java.awt.Insets(2, 10, 10, 10);
    gridBagConstraints8.gridx = 1;
    gridBagConstraints8.gridy = 2;
    gridBagConstraints8.weightx = 1.0;
    gridBagConstraints8.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints8.insets = new java.awt.Insets(2, 10, 10, 10);
    gridBagConstraints9.gridx = 0;
    gridBagConstraints9.gridy = 0;
    jLabel.setText("Type");
    gridBagConstraints10.gridx = 1;
    gridBagConstraints10.gridy = 0;
    jLabel1.setText("Data");
    gridBagConstraints13.gridx = 0;
    gridBagConstraints13.gridy = 3;
    gridBagConstraints13.weightx = 1.0;
    gridBagConstraints13.weighty = 1.0;
    gridBagConstraints13.fill = java.awt.GridBagConstraints.BOTH;
    gridBagConstraints13.gridwidth = 2;
    gridBagConstraints13.insets = new java.awt.Insets(10, 10, 10, 10);
    gridBagConstraints17.gridx = 2;
    gridBagConstraints17.gridy = 2;
    gridBagConstraints17.fill = java.awt.GridBagConstraints.VERTICAL;
    gridBagConstraints17.insets = new java.awt.Insets(10, 10, 10, 10);
    gridBagConstraints17.gridheight = 2;
    this.add(getTypeTextField(), gridBagConstraints7);
    this.add(getDataTextField(), gridBagConstraints8);
    this.add(jLabel, gridBagConstraints9);
    this.add(jLabel1, gridBagConstraints10);
    this.add(getJScrollPane(), gridBagConstraints13);
    this.add(getJPanel(), gridBagConstraints17);
  }

  /**
   * This method initializes jContentPane
   * 
   * @return javax.swing.JPanel
   */
  private javax.swing.JPanel getJContentPane()
  {
    if (jContentPane == null)
    {
      jContentPane = new javax.swing.JPanel();
      jContentPane.setLayout(new java.awt.BorderLayout());
    }
    return jContentPane;
  }

  /**
   * This method initializes jComboBox
   * 
   * @return javax.swing.JComboBox
   */
  private JFormattedTextField getDataTextField()
  {
    if (DataTextField == null)
    {
      DataTextField = new JFormattedTextField(new DefaultFormatter());

      DataTextField.addPropertyChangeListener("value",
          new PropertyChangeListener() {

            public void propertyChange(PropertyChangeEvent evt)
            {
              try
              {
                if (evt.getNewValue() != null)
                  _proxyTuple.setData((String) evt.getNewValue());
                DataTextField.setBackground( UIManager.getColor(
                                             "Textfield.background") );
              }
              catch (Exception e)
              {
                _proxyTuple.setValid(false);
                DataTextField.setBackground(Color.RED);
              }

            }

          });

    }

    return DataTextField;
  }

  /**
   * This method initializes jFormattedTextField
   * 
   * @return javax.swing.JFormattedTextField
   */
  private JFormattedTextField getTypeTextField()
  {
    if (TypeTextField == null)
    {
      MaskFormatter form = null;

      try
      {
        form = new MaskFormatter("***");
      }
      catch (ParseException e)
      {
        e.printStackTrace();
        System.exit(-1);
      }

      TypeTextField = new JFormattedTextField(form);

      TypeTextField.addPropertyChangeListener("value",
          new PropertyChangeListener() {

            public void propertyChange(PropertyChangeEvent evt)
            {
              _proxyTuple.setType((String) evt.getNewValue());
            }

          });
    }
    return TypeTextField;
  }

  /**
   * This method initializes jTable
   * 
   * @return javax.swing.JTable
   */
  private JTable getJTable()
  {
    if (jTable == null)
    {
      jTable = new JTable();
      jTable.setModel(getPacket());
      MaskFormatter form = null;

      try
      {
        form = new MaskFormatter("***");
      }
      catch (ParseException e)
      {
        e.printStackTrace();
        System.exit(-1);
      }

      JFormattedTextField myTypeTextField = new JFormattedTextField(form);
      
      jTable.getColumnModel().getColumn(0).setCellEditor(
          new DefaultCellEditor(myTypeTextField));
    }
    return jTable;
  }

  /**
   * This method initializes jScrollPane
   * 
   * @return javax.swing.JScrollPane
   */
  private JScrollPane getJScrollPane()
  {
    if (jScrollPane == null)
    {
      jScrollPane = new JScrollPane();
      jScrollPane.setViewportView(getJTable());
    }
    return jScrollPane;
  }

  /**
   * This method initializes jPanel
   * 
   * @return javax.swing.JPanel
   */
  private JPanel getJPanel()
  {
    if (jPanel == null)
    {
      GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
      GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
      jPanel = new JPanel();
      jPanel.setLayout(new GridBagLayout());
      gridBagConstraints18.gridx = 0;
      gridBagConstraints18.gridy = 0;
      gridBagConstraints18.insets = new java.awt.Insets(5, 5, 5, 3);
      gridBagConstraints18.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints18.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints19.gridx = 0;
      gridBagConstraints19.gridy = 1;
      gridBagConstraints19.insets = new java.awt.Insets(5, 3, 5, 3);
      gridBagConstraints19.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints19.fill = java.awt.GridBagConstraints.HORIZONTAL;
      gridBagConstraints20.gridx = 0;
      gridBagConstraints20.gridy = 2;
      gridBagConstraints20.insets = new java.awt.Insets(5, 3, 5, 3);
      gridBagConstraints20.anchor = java.awt.GridBagConstraints.NORTH;
      gridBagConstraints20.fill = java.awt.GridBagConstraints.HORIZONTAL;
      jPanel.add(getAddButton(), gridBagConstraints18);
      jPanel.add(getRemoveButton(), gridBagConstraints19);
      jPanel.add(getClearButton(), gridBagConstraints20);
    }
    return jPanel;
  }

  /**
   * This method initializes addButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getAddButton()
  {
    if (addButton == null)
    {
      addButton = new JButton();
      addButton.setText("add");
      addButton.setPreferredSize(new java.awt.Dimension(80, 23));
      addButton.setAction(new AddParticleTuple(_ppacket, _proxyTuple));
    }
    return addButton;
  }

  /**
   * This method initializes removeButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getRemoveButton()
  {
    if (removeButton == null)
    {
      removeButton = new JButton();
      removeButton.setText("remove");
      removeButton.setPreferredSize(new java.awt.Dimension(80, 23));
      removeButton.setAction(new RemoveParticleTuple(_ppacket, getJTable()));
    }
    return removeButton;
  }

  /**
   * This method initializes clearButton
   * 
   * @return javax.swing.JButton
   */
  private JButton getClearButton()
  {
    if (clearButton == null)
    {
      clearButton = new JButton();
      clearButton.setText("clear");
      clearButton.setPreferredSize(new java.awt.Dimension(80, 23));
      clearButton.setAction(new ClearPacket(_ppacket));
    }
    return clearButton;
  }

  /*
   * ========================================================================
   * Bean Properties.
   * ========================================================================
   */
  protected ProxyParticlePacket _ppacket = null;

  public ProxyParticlePacket getPacket()
  {
    if (_ppacket == null)
    {
      _ppacket = new ProxyParticlePacket();
    }

    return _ppacket;
  }
}
