package edu.teco.particles.pComponent.test;

import edu.teco.particles.libParticle.ParticlePacket;
import edu.teco.particles.libParticle.ParticleSrcId;
import edu.teco.particles.libParticle.ParticleTuple;
import edu.teco.particles.pComponent.io.DeviceTemplate;
import edu.teco.particles.pComponent.io.ParticleTemplate;
import junit.framework.TestCase;

/*
 * Copyright (c) 2004, 2005
 * Telecooperation Office (TecO), Universitaet Karlsruhe (TH), Germany.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 3. Neither the name of the Universitaet Karlsruhe (TH) nor the names
 *    of its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

/**
 * @author scholl
 */
public class TestDeviceTemplate extends TestCase
{
  static
  {
    System.loadLibrary("particleJava");
  }

  public void testArraySerializing()
  {
    ParticleSrcId srcid = new ParticleSrcId("1.254.128.127.3.2.255.0");
    ParticleTemplate temp = new DeviceTemplate(srcid);

    ParticlePacket pck = temp.packet(null, null);

    for (int i = 0; i < 8; i++)
    {
      assertEquals(srcid.toArray()[i], pck.findFirstAcl("CAD").toArray()[i]);
    }
  }

  public void testMatching()
  {
    ParticleSrcId srcid = new ParticleSrcId("1.254.128.127.3.2.255.0");
    ParticleTemplate temp = new DeviceTemplate(srcid);

    ParticlePacket pck = new ParticlePacket();
    pck.setSrcId(srcid);

    assertTrue(temp.match(pck));
  }
}
